#############################################################################################
# Somma tutti gli elementi di una matrice, caricata a tempo di assemblaggio, tramite lo     #
# ausilio di una funzione ricorsiva, che calcola la somma di tutti gli elementi su una riga #
#############################################################################################

.text
	la $a0, M			# puntatore alla matrice
	li $a1, 0			# indice della riga iniziale
	lw $a2, dimR			# numero di righe della matrice
	lw $a3, dimC			# numero di elementi su ciascuna riga
	
	jal somma_matrice

	move $a0, $v0
	li $v0, 1
	syscall
	
	li $v0, 10
	syscall

##################################################
somma_matrice:
	blt $a1, $a2, endif_1		# righe finite: ritorno (con 0 come "somma")!
		li $v0, 0
		jr $ra
	endif_1:
	
	subu $sp, $sp, 8
	sw $a1, 4($sp)
	sw $ra,  ($sp)
	
	addi $a1, $a1, 1		# ...riga subito successiva!
	
	jal somma_matrice		# chiamata ricorsiva a "somma_matrice"
	
	move $t0, $v0			# salvo il valore di ritorno!
	
	lw $ra,  ($sp)
	lw $a1, 4($sp)
	addu $sp, $sp, 8
	
	mul $t1, $a1, $a3		# calcolo l'offset dove spostare il 
	sll $t1, $t1, 2			# puntatore alla matrice, calcolando 
	add $t1, $a0, $t1		# il numero di elementi da saltare
	
	subu $sp, $sp, 24
	sw $a0, 20($sp)
	sw $a1, 16($sp)
	sw $a2, 12($sp)
	sw $a3,  8($sp)
	sw $t0,  4($sp)
	sw $ra,   ($sp)
	
	move $a0, $t1			# preparo i parametri di input per
	li $a1, 0			# la successiva chiamata ricorsiva
	move $a2, $a3			# alla funzione che somma su riga
	
	jal somma_vettore
	
	lw $ra,   ($sp)
	lw $t0,  4($sp)
	lw $a3,  8($sp)
	lw $a2, 12($sp)
	lw $a1, 16($sp)
	lw $a0, 20($sp)
	addu $sp, $sp, 24

	add $v0, $t0, $v0		# tengo conto del risultato della chiamata
	
	jr $ra
##################################################	

##################################################
somma_vettore:
	bne $a1, $a2, endif_2		# vettore terminato!
		li $v0, 0
		jr $ra
	endif_2:

	move $t0, $a1
	sll $t0, $t0, 2
	add $t1, $a0, $t0
	lw $t0, ($t1)			# recupero valore V[i]
	
	subu $sp, $sp, 12
	sw $a1, 8($sp)
	sw $t0, 4($sp)
	sw $ra,  ($sp)
	
	addi $a1, $a1, 1
	
	jal somma_vettore
	
	lw $ra,  ($sp)
	lw $t0, 4($sp)
	lw $a1, 8($sp)
	addu $sp, $sp, 12
	
	add $v0, $t0, $v0
	
	jr $ra
##################################################


.data
	M:	.word    1,  3,  5,  7,
			11, 13, 15, 17,
			 2,  4,  6,  8
	dimR:	.word 3
	dimC:	.word 4
